using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace imageTracingWindow
{
    public partial class Form1 : Form
    {
        private Boolean proportionFlag = true;
        private System.Drawing.Size lastSize;
        private System.Drawing.Point lastLocation;

        // RXgN^
        // ɃEChE𓧖ɂĂB
        public Form1()
        {
            InitializeComponent();
            this.Opacity = 0.98;
            proportionFlag = true;
            prop_ToolStripMenuItem.Checked = true;
        }

        // ʃ_uNbNB
        // t@CIEChE\Ă邾B
        private void pictureBox1_DoubleClick(object sender, EventArgs e)
        {
            this.openFileDialog1.Filter =
                "IMG t@C(*.jpg;*.jpeg)|*.jpg;*.jpeg;*.png;*.gif;*.bmp|ׂẴt@C(*.*)|*.*";
            if (this.openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                this.pictureBox1.Image = Image.FromFile(this.openFileDialog1.FileName);
                this.Width = this.pictureBox1.Image.Width;
                this.Height = this.pictureBox1.Image.Height;
                this.pictureBox1.SizeMode = PictureBoxSizeMode.StretchImage;
            }
        }

        // }EXzC[̃Cxg
        // EChE߃iVɂƈu삪̂
        // ߃iVɂȂ悤ɐ䂵ĂB
        private void pictureBox1_MouseWheel(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            double d = 0.02;
            if (e.Delta > 0)
            {
                if (this.Opacity < 0.98)
                    this.Opacity += d;
            }
            else
            {
                if (this.Opacity > 0.12)
                    this.Opacity -= d;
            }
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
        }


        // ʂ̑傫ςƂ̃CxgB
        // ܂oOĂB
        private void Form1_Resize(object sender, EventArgs e)
        {
            if (pictureBox1.Image != null && proportionFlag)
            {
                if (pictureBox1.Image.Width > 0 && pictureBox1.Image.Height > 0)
                {
                    double p = pictureBox1.Image.Height / (double)pictureBox1.Image.Width;
                    this.Size = new Size(this.Width, 
                        (int)((this.Width - (SystemInformation.Border3DSize.Width * 2)) * p) +
                        SystemInformation.CaptionHeight + SystemInformation.Border3DSize.Height);
                }
            }
        }

        private void prop_ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ToolStripMenuItem item = (ToolStripMenuItem)sender;
            item.Checked = true;
            proportionFlag = !proportionFlag;
            item.Checked = proportionFlag ? true : false;
        }

        private void pictureBox1_MouseClick(object sender, MouseEventArgs e)
        {
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            Properties.Settings.Default.Size = this.Size;
            Properties.Settings.Default.Save();
        }

        private void LoadWindow_ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Location = Properties.Settings.Default.UserLocation;
            this.Size = Properties.Settings.Default.UserSize;
        }

        private void LoadLastEndToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Location = lastLocation;
            this.Size = lastSize;
        }

        private void SaveWindow_ToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            Properties.Settings.Default.UserLocation = this.Location;
            Properties.Settings.Default.UserSize = this.Size;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            lastSize = Properties.Settings.Default.Size;
            lastLocation = Properties.Settings.Default.Location;
            this.Size = lastSize;
        }
    }
}